%Computing empirical Mean-to-Variance Ratio (MVR)
%Zhu and Zeng (2006): Fourier method, modified Ex 3
%Discrete Y
%n=200, sig=3

sig=3;
p=10;d=2;
rep=200;

true1=[ones(1,4),zeros(1,p-4)]';
true2=[zeros(1,p-4),ones(1,4)]';

mvr=zeros(rep,1);

for i=1:rep
    %i
    %x=normrnd(0,1,n,p);
    %x = mvnrnd(mu,sigma,n);
    %x=-sqrt(3) + 2*sqrt(3)*rand(n,p);
    %e=normrnd(0,1,n,1);
    i      % data-file index     
    filename=strcat('dataInd200Sig3_',num2str(i),'.txt');
    data=dlmread(filename);
    x=data(:,1:p);
    y=data(:,p+1);  
    
    gamma1=x*true1;
    gamma2=x*true2;
    %y= ((gamma1 + sig.*e) > 1) + 2.*((gamma2 .* (sig.*e)) > 1);
    
    a1=(1-gamma1)./sig;
    p1=normcdf(-a1);
    
    a2=(sig*abs(gamma2)).^(-1);
    p2=normcdf(-a2).*(gamma2 ~= 0);
    
    condMean = p1 + 2*p2;
    VE = var(condMean);
    
    a12_1=max(a1,(sig*gamma2).^(-1));
    a12_2=max(0,normcdf((sig*gamma2).^(-1)) - normcdf(a1));
    p12=normcdf(-a12_1).*(gamma2 >= 0) + a12_2.*(gamma2 < 0);
    v1=p1.*(1-p1);
    v2=p2.*(1-p2);
    cov12=p12 - p1.*p2;
    condVar = v1+4.*v2+2.*cov12;
    EV = mean(condVar);
    
    mvr(i)=VE/EV;    
end

m=mean(mvr);
format shortG
round(m,4) %0.1175

save avgMVR_n200Sig3.mat

    
    