function[out]=phd(x,y)
%[out]=phd(x,y) does the dimension reduction based on 
%principal Hessian Directions. Each row of x and y represent 
%an observation.
%OUTPUT:
%       out.ydirection--the direction found based on y
%       out.rdirection--the direction found based on residual r. 

n=length(y);X=[ones(n,1),x];
err=y-X*(X'*X)^(-1)*X'*y;

covyxx=0;covrxx=0;mx=mean(x);my=mean(y);
for i=1:n
    covyxx=covyxx+(y(i)-my)*(x(i,:)-mx)'*(x(i,:)-mx);
    covrxx=covrxx+err(i)*(x(i,:)-mx)'*(x(i,:)-mx);
end
covyxx=covyxx/n;
maty=(cov(x)*(n-1)/n)^(-1)*covyxx;
[sv,sd]=eig(maty); 
temp=diag(sd);[a,b]=sort(-abs(temp));sd=temp(b);sv=sv(:,b);
out.ydirection=sv;
out.yeigenvalue=sd;

covrxx=covrxx/n;
matr=(cov(x)*(n-1)/n)^(-1)*covrxx;
[sv,sd]=eig(matr); 
temp=diag(sd);[a,b]=sort(-abs(temp));sd=temp(b);sv=sv(:,b);
out.rdirection=sv;
out.reigenvalue=sd;